#
#    Fit 2-d smooth models
#
#    rm(list = ls())
#
#    Get some data
#
source("/home/iain/Dropbox/CUP/IDC/R/Read_HMD.r")
#
Death.Data = Read.HMD("Data/HMD_UK_Deaths_2013.txt")
names(Death.Data)
Exposure.Data = Read.HMD("Data/HMD_UK_Exposures_2013.txt")
names(Exposure.Data)
#
Age = Death.Data$Age; Age
Year = Death.Data$Year; Year
#    Choose male data for ages 50 to 90 and years 1961 to 2013
AGE = 50:90
YEAR = 1961:2013 
Dth = Death.Data$Male.Matrix[(Age > 49) & (Age < 91), Year > 1960]
Exp = Exposure.Data$Male.Matrix[(Age > 49) & (Age < 91), Year > 1960]
Obs = log(Dth/Exp)
n.x = nrow(Dth)
n.y = ncol(Dth)
#  Install MortalitySmooth package
library("svcm", lib.loc = "/home/iain/reml/R.LIBRARIES")
library("MortalitySmooth", lib.loc = "/home/iain/reml/R.LIBRARIES")
#  Fit model
Fit.2d = Mort2Dsmooth(AGE, YEAR, Dth, offset=log(Exp))
names(Fit.2d)
#     Choose log(mu) for years 1961, 1980, 2000, 2013 
logm.hat = Fit.2d$logm[ , c(1, 20, 40, 53)]
logm.hat[1:5, ]
par(mar=c(4.2, 4, 1, 0.5), mgp=c(3, 1, 0), las=1, cex=1)
matplot(AGE, logm.hat, type = "l", col = 1, axes = FALSE,
        xlab = "Age", ylab = expression(log(mu)))
axis(1, las = 1, at = seq(40,90,10)); axis(2, las = 1, at = seq(-6,-1,1))
matpoints(AGE, Obs[ , c(1, 20, 40, 53)], pch = 1:4, col = 1)
legend("topleft", legend = YEAR[c(1, 20, 40, 53)], lty = 1:4,
       pch = 1:4, bty = "n")
#
#     Calculate mortality improvements from 1961 to 2013 and plot them
#
Diff = Fit.2d$logm[,1] - Fit.2d$logm[,53]
par(mar=c(4.2, 4, 0, 0.5), mgp=c(3, 1, 0), las=1, cex=1)
plot(AGE, Diff, xlab = "Age", xlim = c(50, 90), ylim = c(0.5, 1.2),
     ylab = expression(log(mu[1961]) - log(mu[2013])), axes = FALSE)
axis(1,las = 1, at = seq(40, 100, by = 10), tcl = -0.4)
axis(2, seq(0.4,1.2, by = 0.1), tcl = -0.4)

